/**
 * Copyright (C) 2007-2013 eBay Inc. All Rights Reserved.
 */

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

/**
 * Provides the functionality to the about dialog
 * @author jmrodriguez Glaxstar Corp.
 */
var About = {

  /**
   * Initializes the resource.
   */
  init : function() {
    try {
      Cu.import("resource://ebaycompanion/helpers/logger.js");
      Cu.import("resource://ebaycompanion/constants.js");

      let bundle = Constants.stringBundle;
      let versionNumber = Constants.prefBranch.get("version");
      let userAgent = document.getElementById("useragent");
      userAgent.appendChild(
        document.createTextNode(
          bundle.getString(
            "ecAbout.edition.label", [navigator.userAgent])));
      document.getElementById("version").value =
        bundle.getString("ecAbout.version.label", [versionNumber]);

    } catch (e) {
      Logger.exception(e, Logger.DUMP_STACK)
    }
  },

  /**
   * Loads feedback page.
   */
  loadFeeback : function() {
    var url =
      Constants.getUrl("unwrappedLink", "appFeedback");
    this._loadPage(url);
  },

  /**
   * Loads an url.
   * @param aUrl the url to be loaded.
   */
  _loadPage : function(aUrl) {
    var windowMediator =
       Cc["@mozilla.org/appshell/window-mediator;1"].
         getService(Ci.nsIWindowMediator);
    var win = windowMediator.getMostRecentWindow("navigator:browser");
    if (win) {
      win.openUILinkIn(aUrl, "tab");
    } else {
      window.open(aUrl);
    }
  }

}
