/**
 * Copyright (C) 2007-2013 eBay Inc. All Rights Reserved.
 */

var EXPORTED_SYMBOLS = ["EventAnalytics"];

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

Cu.import("resource://ebaycompanion/common.js");
Cu.import("resource://ebaycompanion/helpers/logger.js");

var EventAnalytics = {

  _cookie : null,

  rand : function(min, max) {
    return min + Math.floor(Math.random() * (max - min));
  },

  init: function() {
    Cu.import("resource://ebaycompanion/datasource.js");
    Cu.import("resource://ebaycompanion/helpers/utilityHelper.js");
    this._cookie= this.rand(10000000,99999999); //random cookie number
  },

  pageView: function() {
    /*if (this._IS_ENABLED) {
      _gaq.push(['_setAccount', 'UA-35902936-1']);
      _gaq.push(['_trackPageview']);
    }*/

    try {
      var i=1000000000,
          utmwv = '5.3.9',
          utms = Datasource.getAnalyticsCount(),
          utmn = this.rand(i,9999999999), //random request number
          utmhn = 'extensions.ebay.com',
          utmt = 'event',
          utmcs = 'ISO-8859-1',
          utmsr = 800 + 'x' + 600,
          utmsc = 24 + '-bit',
          utmul = UtilityHelper.getSelectedLocale().toLowerCase(),
          utmhid = this.rand(i,9999999999),
          utmr = '-',
          utmp = 'browser.xul',
          utmac = 'UA-18459076-7',
          cookie= this._cookie;
          random= this.rand(i,2147483647), //number under 2147483647
          today=(new Date()).getTime(),
          utmcc = '__utma%3D'
              +cookie+'.'+random+'.'+today+'.'+today+'.'
              +today+'.2%3B%2B__utmb%3D'
              +cookie+'%3B%2B__utmc%3D'
              +cookie+'%3B%2B__utmz%3D'
              +cookie+'.'+today
              +'.1.1.utmcsr%3D(direct)%7Cutmccn%3D(direct)%7Cutmcmd%3D(none)%3B'
              +cookie+'.-%3B',
          urchinUrl = 'http://www.google-analytics.com/__utm.gif?'
              +'utmwv='+utmwv
              +'&utms='+utms
              +'&utmn='+utmn
              +'&utmhn='+utmhn
              +'&utmcs='+utmcs
              +'&utmsr='+utmsr
              +'&utmsc='+utmsc
              +'&utmul='+utmul
              +'&utmhid='+utmhid
              +'&utmr='+utmr
              +'&utmp='+utmp
              +'&utmac='+utmac
              +'&utmcc='+utmcc
              +'&utmu=q~';

      //dump("first request: " + urchinUrl + "\n");
      // trigger the tracking
      //img.src = urchinUrl;
      this._sendRequest(urchinUrl);
    } catch(e) {
      Logger.error(e, Logger.DUMP_STACK);
    }

  },

  push: function(aArray) {
    try {
      var i=1000000000,
          utmwv = '5.3.9',
          utms = Datasource.getAnalyticsCount(),
          utmn = this.rand(i,9999999999), //random request number
          utmhn = 'extensions.ebay.com',
          utmt = 'event',
          utme = 5 + '(' + aArray[1] + '*' + aArray[2] + ')',
          utmcs = 'ISO-8859-1',
          utmsr = 800 + 'x' + 600,
          utmsc = 24 + '-bit',
          utmul = UtilityHelper.getSelectedLocale().toLowerCase(),
          utmhid = this.rand(i,9999999999),
          utmr = '-',
          utmp = 'browser.xul',
          utmac = 'UA-18459076-7',
          cookie= this._cookie,
          random= this.rand(i,2147483647), //number under 2147483647
          today=(new Date()).getTime(),
          utmcc = '__utma%3D'
              +cookie+'.'+random+'.'+today+'.'+today+'.'
              +today+'.2%3B%2B__utmb%3D'
              +cookie+'%3B%2B__utmc%3D'
              +cookie+'%3B%2B__utmz%3D'
              +cookie+'.'+today
              +'.1.1.utmcsr%3D(direct)%7Cutmccn%3D(direct)%7Cutmcmd%3D(none)%3B'
              +cookie+'.-%3B',
          urchinUrl = 'http://www.google-analytics.com/__utm.gif?'
              +'utmwv='+utmwv
              +'&utms='+utms
              +'&utmn='+utmn
              +'&utmhn='+utmhn
              +'&utmt='+utmt
              +'&utme='+utme
              +'&utmcs='+utmcs
              +'&utmsr='+utmsr
              +'&utmsc='+utmsc
              +'&utmul='+utmul
              +'&utmhid='+utmhid
              +'&utmr='+utmr
              +'&utmp='+utmp
              +'&utmac='+utmac
              +'&utmcc='+utmcc
              +'&utmu=6~';

      //dump("push: " + urchinUrl + "\n");
      // trigger the tracking
      //img.src = urchinUrl;
      this._sendRequest(urchinUrl);
    } catch(e) {
      Logger.error(e, Logger.DUMP_STACK);
    }
  },

  _sendRequest : function(aUrl) {
    let request =
      Cc["@mozilla.org/xmlextras/xmlhttprequest;1"].
        createInstance(Ci.nsIXMLHttpRequest);

    request.open("GET", aUrl, true);
    request.addEventListener(
      "load",
      function() {
        Logger.log("GA request success: " + request.statusText + "\n");
      },
      false);
    request.addEventListener(
      "error",
      function() {
        Logger.error("GA request failed: " + request.statusText + "\n");
      },
      false);
    request.send(null);


  }
};
