/**
 * Copyright (C) 2011-2013 eBay Inc. All Rights Reserved.
 */

var EXPORTED_SYMBOLS = ["Observers", "Topics"];

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

Cu.import("resource://ebaycompanion/common.js");

Topics = {
  // System
  get QUIT_APPLICATION() { return "quit-application"; },
  get QUIT_APPLICATION_GRANTED() { return "quit-application-granted"; },
  get EM_ACTION_REQUESTED() { return "em-action-requested"; },
  get HTTP_ON_MODIFY_REQUEST() { return "http-on-modify-request"; },
  // Items
  get ITEM_NEW() { return "ebaycomp-item-new"; },
  get ITEM_REMOVED() { return "ebaycomp-item-removed"; },
  get ITEM_CHANGED() { return "ebaycomp-item-changed"; },
  get ITEM_PROPERTY_UPDATED() { return "ebaycomp-item-property-updated"; },
  get ITEM_TIME_ADJUSTED() { return "ebaycomp-item-time-adjusted"; },
  get ITEM_HIGHTLIGHT() { return "ebaycomp-item-hightlight"; },
  get ITEM_SHOW_DETAILS() { return "ebaycomp-item-show-details"; },
  get ITEM_HIDE_DETAILS() { return "ebaycomp-item-hide-details"; },
  // Transactions
  get TRANSACTION_NEW() { return "ebaycomp-transaction-new"; },
  get TRANSACTION_REMOVED() { return "ebaycomp-transaction-removed"; },
  get TRANSACTION_CHANGED() { return "ebaycomp-transaction-changed"; },
  get TRANSACTION_ITEM_REMOVED() {
    return "ebaycomp-transaction-item-removed"; },
  get TRANSACTION_PROPERTY_UPDATED() {
    return "ebaycomp-transaction-property-updated"; },
  // Account
  get ACCOUNT_LOGGED_IN() { return "ebaycomp-account-logged-in"; },
  get ACCOUNT_LOGGED_OUT() { return "ebaycomp-account-logged-out"; },
  get ACCOUNT_PROPERTY_UPDATED() {
    return "ebaycomp-account-property-updated"; },
  get ACCOUNT_FEEDBACK_CHANGED() {
    return "ebaycomp-account-feedback-changed"; },
  get ACCOUNT_UNREAD_MESSAGES_CHANGED() {
    return "ebaycomp-account-unread-messages-changed"; },
  // Sidebar
  get UPDATE_STARTED() { return "ebaycomp-update-started"; },
  get UPDATE_FINISHED() { return "ebaycomp-update-finished"; },
  get SIGN_IN_STOP() { return "ebaycomp-sign-in-stop"; },
  get SIGN_IN_START() { return "ebaycomp-sign-in-start"; },
  get SIDEBAR_LIST_RESET() { return "ebaycomp-sidebar-list-reset"; },
  get LIST_RESET_CURRENT_FILTER() {
    return "ebaycomp-list-reset-current-filter"; },
  get LIST_APPLY_FILTER() { return "ebaycomp-list-apply-filter"; },
  get LIST_FORCE_APPLY_FILTER() { return "ebaycomp-list-force-apply-filter"; },
  get SIDEBAR_APPLY_TAB() { return "ebaycomp-sidebar-apply-tab";},
  get SIDEBAR_ENFORCE_TAB() { return "ebaycomp-sidebar-enforce-tab";},
  // System message
  get SYSTEM_MESSAGE_PROPERTY_UPDATED() {
    return "ebaycomp-system-message-property-updated"; },
  // Alerts
  get ALERT_DISPATCHED() { return "ebaycomp-alert-dispatched"; },
  get ALERT_CLOSE_ITEM() { return "ebaycomp-alert-close-item"; },
  get ALERT_SHOW_ITEM() { return "ebaycomp-alert-show-item"; },
  get ALERT_SHOW_PRIMARY() { return "ebaycomp-alert-show-primary"; },
  get ALERT_SHOW_SECONDARY() { return "ebaycomp-alert-show-secondary"; },
  get ALERT_SECONDARY_DISMISSED() {
    return "ebaycomp-alert-secondary-dismissed"; },
  // Notifications
  get NOTIFICATION_WARN_SHOW() { return "ebaycomp-notification-warn-show"; },
  get NOTIFICATION_INFO_SHOW() { return "ebaycomp-notification-info-show"; },
  get NOTIFICATION_WARN_CLEAR() { return "ebaycomp-notification-warn-clear"; },
  get NOTIFICATION_SIGNED_IN_WARN_CLEAR() { return "ebaycomp-notification-signed-in-warn-clear"; },
  get NOTIFICATION_INFO_CLEAR() { return "ebaycomp-notification-info-clear"; },
  // API
  get API_REQUEST_TIMEOUT() { return "ebaycomp-api-request-timeout"; },
  get API_TRADING_TOKEN() { return "ebaycomp-api-trading-token"; },
  get API_TRADING_CALL() { return "ebaycomp-api-trading-call"; },
  get API_FINDING_CALL() { return "ebaycomp-api-finding-call"; },
  get API_SHOPPING_CALL() { return "ebaycomp-api-shopping-call"; },
  get API_CLIENT_ALERTS_CALL() { return "ebaycomp-api-client-alerts-call"; },
  get API_MY_EBAY_APPLICATION_CALL() {
    return "ebaycomp-api-my-ebay-application-call"; },
  // Accordion
  get FAVORITE_SELLERS_UPDATED() {
    return "ebaycomp-favorite-sellers-updated"; },
  get FAVORITE_SEARCHES_UPDATED() {
    return "ebaycomp-favorite-searches-updated"; },
  get DAILY_DEAL_UPDATED() { return "ebaycomp-daily-deal-updated"; },
  get DAILY_DEALS_UPDATED() { return "ebaycomp-daily-deals-updated"; },
  get DAILY_DEALS_INFO_UPDATED() {
    return "ebaycomp-daily-deals-info-updated"; },
  get DEAL_SHOW_DETAILS() { return "ebaycomp-deal-show-details"; },
  get DEAL_HIDE_DETAILS() { return "ebaycomp-deal-hide-details"; },
  // Autocomplete
  get AUTOCOMPLETE_RESULTS() { return "ebaycomp-autocomplete-results"; },
  // Tracking
  get TRACKED_URLS_LIMIT_REACHED() {
    return "ebaycomp-tracked-urls-limit-reached"; },
  get RECENT_SEARCHES_UPDATED() {
    return "ebaycomp-recent-searches-updated"; },
  get RECENT_BIDS_UPDATED() {
    return "ebaycomp-recent-bids-updated"; },
  get RECENT_VIEWS_UPDATED() {
    return "ebaycomp-recent-views-updated"; },
  get RECENT_WATCHES_UPDATED() {
    return "ebaycomp-recent-watches-updated"; },
  get RECENT_ALERTS_UPDATED() {
    return "ebaycomp-recent-alerts-updated"; },
  get RECENT_SEARCHES_REMOVED() {
    return "ebaycomp-recent-searches-removed"; },
  get RECENT_BIDS_REMOVED() {
    return "ebaycomp-recent-bids-removed"; },
  get RECENT_VIEWS_REMOVED() {
    return "ebaycomp-recent-views-removed"; },
  get RECENT_WATCHES_REMOVED() {
    return "ebaycomp-recent-watches-removed"; },
  get RECENT_ALERTS_REMOVED() {
    return "ebaycomp-recent-alerts-removed"; },
  get SEARCH_EXECUTED() {
    return "ebaycomp-search-executed"; }
};

/**
 * Observers.
 */
Observers = {
  /* Observer service. */
  _observerService: null,
  /* Observers hash. */
  _observers: null,

  /**
   * Initializes the resource.
   */
  init : function() {
    this._observerService =
      Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);

    this._observers = new Array();
  },

  /**
   * Calls to add an observer to the class object.
   * @param aClassObject the class object.
   * @param aTopic the associated topic.
   */
  add : function(aClassObject, aTopic) {
    let observer = new Observer(aClassObject);
    let index = this._findIndex(aClassObject);

    if (-1 == index) {
      this._observers.push({ object: aClassObject, topics: {} });
      index = this._observers.length - 1;
    }

    this._observers[index].topics[aTopic] = observer;
    this._observerService.addObserver(observer, aTopic, false);
  },

  /**
   * Calls to remove an observer to the class object.
   * @param aClassObject the class object.
   * @param aTopic the associated topic.
   */
  remove : function(aClassObject, aTopic) {
    let index = this._findIndex(aClassObject);

    if (-1 != index) {
      let observer = this._observers[index].topics[aTopic];

      this._observerService.removeObserver(observer, aTopic);
      delete this._observers[index].topics[aTopic];
    }
  },

  /**
   * Calls to remove an observer to the class object.
   * @param aClassObject the class object.
   * @param aTopic the associated topic.
   */
  removeAll : function(aClassObject) {
    let index = this._findIndex(aClassObject);

    if (-1 != index) {
      for (let topic in this._observers[index].topics) {
        this.remove(aClassObject, topic);
      }
    }
  },

  /**
   * Calls to notify an observer.
   * @param aSubject the observer subject.
   * @param aTopic the observer topic.
   * @param aData the observer data.
   */
  notify : function(aSubject, aTopic, aData) {
    let subject = new Object();

    try {
      subject.wrappedJSObject = aSubject;
      this._observerService.notifyObservers(subject, aTopic, aData);
    } catch (e) {
    }
  },

  /**
   * Finds the index in the observers array.
   * @param aValue the value.
   * @return the index if found, -1 otherwise.
   */
  _findIndex : function(aValue) {
    let index = -1;

    for (let i = 0; i < this._observers.length; i++) {
      if (aValue == this._observers[i].object) {
        index = i;
        break;
      }
    }

    return index;
  }
};

/**
 * Constructor.
 */
(function() { this.init(); }).apply(Observers);

/**
 * Observers.
 */
function Observer(aClassObject) {
  this._classObject = aClassObject;
}

Observer.prototype = {
  /* Class object. */
  _classObject : null,

  /**
   * Observes global topic changes.
   * @param aSubject the object that experienced the change.
   * @param aTopic the topic being observed.
   * @param aData the data relating to the change.
   */
  observe : function(aSubject, aTopic, aData) {
    if (aSubject && aSubject.wrappedJSObject) {
      this._classObject.observe(aSubject.wrappedJSObject, aTopic, aData);
    } else {
      this._classObject.observe(aSubject, aTopic, aData);
    }
  }
};
