/**
 * Copyright (C) 2007-2013 eBay Inc. All Rights Reserved.
 */

var EXPORTED_SYMBOLS = ["DOMListUrl"];

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

Cu.import("resource://ebaycompanion/helpers/objectHelper.js");

/**
 * eBay DOMListUrl records
 */
function DOMListUrl(aId) {
  this.set("id", aId);
}

DOMListUrl.prototype = {
  /**
   * Used to determine the type of the object
   */
  constructor : DOMListUrl,

  /**
   * Types for each property of this object
   */
  propertyTypes : {
    id:  "number",
    storeDomain: "string",
    urlRegExp: "string",
    type: "number",
    title: "string",
    upc: "string",
    isbn: "string",
    ean: "string",
    asin: "string",
    itemModelNumber: "string",
    formattedPrice: "string",
    amount: "string",
    currencyCode: "string"
  },


  /**
   * Returns a copy of this object
   */
  copy : function() {
    let copy = new DOMListUrl();
    copy.updateQuietlyTo(this);
    return copy;
  },

  /**
   * updateTo
   */
  updateTo : function(newObject, flags) {
    return ObjectHelper.
             updateObject(
               this, newObject, "ebay-site-DOM-property-updated", flags);
  },

  /**
   * updateQuietlyTo
   */
  updateQuietlyTo : function(newObject) {
    return this.updateTo(newObject, ObjectHelper.flags.NO_NOTIFICATIONS);
  },

  /**
   * updateProperty
   */
  updateProperty : function(property, value) {
    return ObjectHelper.
             updateProperty(this, property, value,
                            "ebay-site-DOM-property-updated");
  },

  /**
   * Returns the value of the given property
   */
  get : function(property) {
    return ObjectHelper.getProperty(this, property);
  },

  /**
   * Sets the given property to the given value, checking that the value is of
   * the correct type for the property
   */
  set : function(property, value) {
    value = ObjectHelper.
              filterValue(property, this.propertyTypes[property], value);
    this["_" + property] = value;
  }
};
