/**
 * Copyright (C) 2007-2013 eBay Inc. All Rights Reserved.
 */

var EXPORTED_SYMBOLS = ["Product"];

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

Cu.import("resource://ebaycompanion/helpers/objectHelper.js");

/**
 * Product identifier for an item from other shopping sites
 */
function Product() {
}

Product.prototype = {
  /**
   * Used to determine the type of the object
   */
  constructor: Product,

  /**
   * Types for each property of this object
   */
  propertyTypes: {
    title: "string",
    thumbnail: "string",
    productID: "string",
    detailsURL: "string",
    totalCount: "number",
    inventory: "object"
  },

  /**
   * Returns the value of the given property
   */
  get: function(aProperty) {
    return ObjectHelper.getProperty(this, aProperty);
  },

  /**
   * Sets the given property to the given value, checking that the value is of
   * the correct type for the property
   */
  set: function(aProperty, aValue) {
    let value = ObjectHelper.
              filterValue(aProperty, this.propertyTypes[aProperty], aValue);
    this["_" + aProperty] = value;
  }
};
